struct light
{
  vec3 position;
  vec4 ambient;
  vec4 diffuse;
  vec4 specular;

  // only directional light is supported
};

uniform light u_lights[1];

uniform sampler2D   s_texture0; // Base
//uniform samplerCube s_texture1;
uniform sampler2D   s_texture1; // Light
uniform sampler2D   s_texture2; // Normal

varying vec2 v_texCoord0;
//varying vec3 v_R;
varying vec3 v_Ltan;
varying vec3 v_Htan;
varying vec3 v_worldC;
//varying vec4 locLight;
//varying vec4 v_color0;

void main()
{
  //vec3 normal = texture2D(s_texture3, v_texCoord0).xyz * 2.0 - 1.0;
  vec3 L = normalize(v_Ltan);
  vec3 H = normalize(v_Htan);
  vec4 bumpTex = texture2D(s_texture2, v_texCoord0);
  float ndotl = max(0.0,L.z + bumpTex.x - texture2D(s_texture2, v_texCoord0 + L.xy * (1.0/512.0)).x);
  float ndoth = max(0.0,H.z + bumpTex.x - texture2D(s_texture2, v_texCoord0 + H.xy * (1.0/512.0)).x);
  // Lamberts law lighting  I = Iamb + Idiff*max(0,LdotN)
  vec4 v_color0 = vec4(0,0,0,1);
  v_color0 += u_lights[0].ambient;
  v_color0 += (ndotl * u_lights[0].diffuse);
  float specPow = bumpTex.a;
  v_color0 += pow(ndoth,specPow*12.0);

  vec4 baseColor = texture2D(s_texture0, v_texCoord0);
  //vec4 specLight = textureCube(s_texture1, v_R);   // This is light
  vec4 locLight      = texture2D(s_texture1, v_worldC.xz); // Borde vara möjlig att köra i vertexshader
  //vec4 dummy      = texture2D(s_texture2, v_texCoord0);
  
  gl_FragColor = (baseColor * v_color0)*locLight;
  gl_FragColor.a = 1.0;
}