struct light
{
  vec3 position;
  vec4 ambient;
  vec4 diffuse;
  vec4 specular;

  // only directional light is supported
};

const float c_one = 1.0;

uniform light u_lights[1];

attribute vec4 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord0;
attribute vec3 a_tangent;

uniform mat4 u_matWVP;
uniform mat4 u_matW;
uniform mat3 u_matWVInvNormals;
uniform vec3 u_vecEye;
uniform float u_scaleFactor;

varying vec2 v_texCoord0;
//varying vec3 v_R;
varying vec3 v_Ltan;
varying vec3 v_Htan;
varying vec3 v_worldC;
//varying vec4 locLight;
//varying vec4 v_color0;

//uniform sampler2D   s_texture2;

void main()
{
  vec3 n = u_matWVInvNormals * a_normal;
  n = normalize(n);
  vec3 t = u_matWVInvNormals * a_tangent;
  t = normalize(t);
  vec3 b = cross(n,t);
  v_Ltan.x = dot(u_lights[0].position.xyz,t);
  v_Ltan.y = dot(u_lights[0].position.xyz,b);
  v_Ltan.z = dot(u_lights[0].position.xyz,n);

  vec3 positionW = (u_matW * a_position).xyz;
  vec3 V = normalize(u_vecEye - positionW);
  vec3 H = normalize(u_lights[0].position.xyz + V);
  v_Htan.x = dot(H,t);
  v_Htan.y = dot(H,b);
  v_Htan.z = dot(H,n);

  // vec3 positionW = (u_matW * a_position).xyz;
  // vec3 I = positionW - u_vecEye;
  // v_R = reflect(I, a_normal);

  // // Lamberts law lighting  I = Iamb + Idiff*max(0,LdotN)
  // v_color0 = vec4(0,0,0,1);
  // v_color0 += u_lights[0].ambient;
  // float ndotl = max(dot(u_lights[0].position.xyz,n), 0.0);
  // v_color0 += (ndotl * u_lights[0].diffuse);

//  v_worldC = positionW * (1.0/256.0) + vec3(0.5,0.5,0.5);
    v_worldC = positionW * u_scaleFactor + vec3(0.5,0.5,0.5);
  // vec3 v_worldC = positionW * (1.0/256.0) + vec3(0.5,0.5,0.5);
  // locLight      = texture2D(s_texture2, v_worldC.xz);
  
  v_texCoord0 = a_texCoord0;
  gl_Position = u_matWVP * a_position;
}