attribute vec4 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord0;

uniform mat4 u_matWVP;
uniform mat4 u_matW;
uniform vec3 u_vecEye;
uniform mat3 u_matWInvNormals;

uniform float u_scaleFactor;

varying vec2 v_texCoord0;
varying vec3 v_worldC;
varying vec3 v_normal;
varying vec3 v_R;

void main()
{
  vec3 n = u_matWInvNormals * a_normal;
  v_normal = normalize(n);
  
  v_texCoord0 = a_texCoord0;
  gl_Position = u_matWVP * a_position;
  
  // Env map
  vec3 pos  =  vec3(u_matW*a_position);
  vec3 norm = vec3(u_matW*vec4(a_normal,0));
  
  vec3 N = normalize(norm);
  vec3 E = pos - u_vecEye;
  v_R = reflect(E,N);
  
  // Light color
  v_worldC = pos.xyz * u_scaleFactor + vec3(0.5,0.5,0.5);
}