uniform sampler2D s_texture0; // main
uniform sampler2D s_texture1; // blurred highlights

varying vec2 v_texCoord0;


void main()
{
  vec4 bloomColor = texture2D(s_texture1, v_texCoord0) * 1.8;
  
  vec4 originalColor = texture2D(s_texture0, v_texCoord0);
  originalColor *= (vec4(1.0) - clamp(bloomColor, 0.0, 1.0));
  
  gl_FragColor = originalColor + bloomColor;
  gl_FragColor.a = 1.0;
}


#if 0
// unoptimized
float bloomIntensity = 1.5;
float originalIntensity = 1.0;
float bloomSaturation = 1.0;
float originalSaturation = 1.0;

vec4 adjustSaturation(vec4 color, float saturation)
{
  // We define gray as the same color we used in the grayscale shader
  float grey = dot(color.rgb, vec3(0.3, 0.59, 0.11));
  return mix(vec4(grey), color, saturation);
}


void main()
{
  
  vec4 bloomColor = texture2D(s_texture1, v_texCoord0);
  
  vec4 originalColor = texture2D(s_texture0, v_texCoord0);
  
  bloomColor = adjustSaturation(bloomColor, bloomSaturation) * bloomIntensity;
  originalColor = adjustSaturation(originalColor, originalSaturation) * originalIntensity;
  
  originalColor *= (vec4(1.0) - clamp(bloomColor, 0.0, 1.0));

  
  gl_FragColor = originalColor + bloomColor;
  gl_FragColor.a = 1.0;
}
#endif