

uniform sampler2D s_texture0;
uniform sampler2D s_texture1;

varying vec4 v_shadowCoord;
varying vec2 v_texCoord1;

uniform float u_bias;

void main()
{
  vec4 shadeFactor = texture2DProj(s_texture0, v_shadowCoord);
  
  float factor = (1.0 - (step((shadeFactor.z + u_bias) * v_shadowCoord.w, v_shadowCoord.z)*step(v_shadowCoord.z/v_shadowCoord.w,1.0)));
  
  float intensity = 1.0 - texture2D(s_texture1, v_texCoord1).r;
  factor += intensity;
  
  gl_FragColor = vec4((factor+RED),(factor+GREEN),(factor+BLUE),1.0);
}
