uniform samplerCube s_texture0;
varying vec3 v_texCoord0;

void main()
{
#if USE_MODIFIED_TEXTURE_LOOKUP
  const float cube_size = 512.0;
  vec3 v = v_texCoord0;
  
  float M = max(max(abs(v.x), abs(v.y)), abs(v.z));
  float scale = (cube_size - 1.0) / cube_size;
  
  if (abs(v.x) != M) v.x *= scale;
  if (abs(v.y) != M) v.y *= scale;
  if (abs(v.z) != M) v.z *= scale;
  
  vec4 color = textureCube(s_texture0, v);
#else
  vec4 color = textureCube(s_texture0, v_texCoord0);
#endif
  
  gl_FragColor = color;
  gl_FragColor.a = 1.0;
}